/*****************************************************************************/
/*                                                                           */
/*   Analyzer Program                               Version 1.0.0            */
/*                     for Linux-2.0.31 (slockware)                          */
/*                                                                           */
/*         Produced on 3 Dec 1997 by  Naohito Iwasa                          */
/*                                                                           */
/*****************************************************************************/
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <sys/types.h>
#include <stdio.h>
#include <signal.h>
#include "blocker.h"
#include <cfortran.h>
#include <hbook.h>

struct SHM_CC7700 *shmp;
int shmid;
int  analys_block,pos;

void f()
{}

void reset()
{
  int i;
 
/*
  for(i=0;i<10;i++)
    printf("%d ",shmp->analy_com[i]);
  printf("\n");
*/
  if(shmp->analy_com[0]!=0){
    if(shmp->analy_com[1]==0)
      HRESET(0," ");
    else
      for(i=1;i<10;i++){
	if(shmp->analy_com[i]==0)break;
	HRESET(shmp->analy_com[i]," ");
      }
    shmp->analy_com[0]=0;
    analys_block=shmp->block_no-1;
    pos=shmp->buffer[analys_block%MAX_BLOCK].data[3];
  }
  signal(SIGUSR1,reset);
}
int main()
{

  if ((shmid = shmget(SHMKEY, sizeof(struct SHM_CC7700), 0600)) 
      == -1)
    {puts("ANALYZER: Cannot create shared memory"); exit(2);}
  shmp = (struct SHM_CC7700 *)shmat(shmid, 0, 0);
 L0:
  analys_block=shmp->block_no-1;
  pos=shmp->buffer[analys_block%MAX_BLOCK].data[3];
  while(1){
    while(1){
      if(shmp->block_no<analys_block+1)goto L0;
      if(shmp->block_no>analys_block+1)break;
      if(pos < shmp->buffer[analys_block%MAX_BLOCK].data[3])break;
      signal(SIGALRM,f);
      signal(SIGUSR1,reset);
      alarm(1);
      pause();
    }
    if(shmp->block_no > analys_block+MAX_BLOCK){
      analys_block=(shmp->block_no)-MAX_BLOCK+1;
      pos=4;
    }
    if(shmp->buffer[analys_block%MAX_BLOCK].data[pos]==0xffff){
      analys_block++;pos=4;
      continue;
    }
    if(shmp->buffer[analys_block%MAX_BLOCK].data[pos]==DELIM){
      analyze_("ONLINE",&shmp->buffer[analys_block%MAX_BLOCK].data[pos+1]);
      pos+=shmp->buffer[analys_block%MAX_BLOCK].data[pos+1]+1;
    }
    else  pos++;
  }
  return 0;
}

